CREATE CACHED TABLE "TipoDeConta"
(
"Id" INTEGER IDENTITY,
"Nome" VARCHAR,
PRIMARY KEY ("Id")
);

CREATE CACHED TABLE "CartaoCredito" 
(
"Id" INTEGER IDENTITY,
"TipoConta" VARCHAR,
"Operadora" INTEGER,
"TemBanco" BOOLEAN,
"Banco" INTEGER,
"NumeroCartao" VARCHAR,
"DataAbertura" DATE,
"DataValidade" DATE,
"DataFechamento" DATE,
"Limite" DOUBLE,
"LimiteExtra" DOUBLE,
"DataFechaFatura" INTEGER,
"DataPagamento" INTEGER,
"JurosRotativo" DOUBLE,
"JurosFinanciamento" DOUBLE,
"TemPlanoDeFidelidade" BOOLEAN,
"QuantoValeCadaPonto" DOUBLE,
"Descricao" VARCHAR,
FOREIGN KEY ("Operadora") REFERENCES "Entidade" ("Id")
);

insert into "TipoDeConta" ("Nome") values ('aplicacao');
insert into "TipoDeConta" ("Nome") values ('contaCorrente');
insert into "TipoDeConta" ("Nome") values ('cartaoCredito');
update "Lancamento" L1 set "TipoConta"=Select "Id" from "TipoDeConta" L2 where L2."Nome" = L1."TipoConta"

update "ContaCorrente" set "TipoConta"=Select "Id" from "TipoDeConta" where "Nome"='contaCorrente'
update "Aplicacao" set "TipoConta"=Select "Id" from "TipoDeConta" where "Nome"='aplicacao'
update "PrevisaoRendimento" set "TipoConta"=Select "Id" from "TipoDeConta" where "Nome"='aplicacao'

insert into "TipoLancamento" ("Nome", "Descricao", "EhDeSistema", "RealizarPrevisao") VALUES 
	'Transferencias', 'TransferenciasDescricao', true, false;
insert into "TipoLancamento" ("Nome", "SuperTipo", "Descricao", "EhDeSistema", "RealizarPrevisao") VALUES 
	'PagamentoCartao', (select "Id" from "TipoLancamento" where "Nome" = 'Transferencias'), "PagamentoCartaoDescricao", true, true;
insert into "TipoLancamento" ("Nome", "SuperTipo", "Descricao", "EhDeSistema", "RealizarPrevisao") VALUES 
	'CreditoPagamentoCartao', (select "Id" from "TipoLancamento" where "Nome" = 'Transferencias'), 'creditoPagamentoCartaoDescricao', true, true;
insert into "TipoLancamento" ("Nome", "SuperTipo", "Descricao", "EhDeSistema", "RealizarPrevisao") VALUES 
	'Saque', (select "Id" from "TipoLancamento" where "Nome" = 'Transferencias'), "SaqueDescricao", true, true;
insert into "TipoLancamento" ("Nome", "SuperTipo", "Descricao", "EhDeSistema", "RealizarPrevisao") VALUES 
	'Deposito', (select "Id" from "TipoLancamento" where "Nome" = 'Transferencias'), 'DepositoDescricao', true, true;
	
update "TipoLancamento" set "SuperTipo"=(select "Id" from "TipoLancamento" where "Nome" = 'Transferencias') where "Nome"='Aplicacao';
update "TipoLancamento" set "SuperTipo"=(select "Id" from "TipoLancamento" where "Nome" = 'Transferencias') where "Nome"='Resgate';